package com.wtkj.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.wtkj.dto.UpdateUserDTO;
import com.wtkj.entity.ContactOuter;
import com.wtkj.mapper.ContactOuterMapper;
import com.wtkj.service.IContactOuterService;
import lombok.AllArgsConstructor;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springblade.core.tool.api.R;
import org.springblade.system.user.entity.User;
import org.springblade.system.user.feign.IUserClient;
import org.springframework.stereotype.Service;

/**
 * @author Blizzard
 * @create at 2023-09-19 11:04
 * @describe
 */
@Service
@AllArgsConstructor
public class ContactOuterServiceImpl extends BaseServiceImpl<ContactOuterMapper, ContactOuter> implements IContactOuterService {

	private final IUserClient userClient;

	@Override
	public IPage<ContactOuter> selectPage(Long userId, IPage<ContactOuter> page) {
		return page.setRecords(baseMapper.getPage(userId, page));
	}

	@Override
	public IPage<ContactOuter> contactPage(Long deptId, Long userId, IPage<ContactOuter> page) {
		return page.setRecords(baseMapper.getUserPage(deptId, userId, page));
	}

	@Override
	public boolean updateUser(UpdateUserDTO dto) {
		boolean flag = false;
		Long userId = dto.getUserId();
		R<User> userR = userClient.userInfoById(userId);
		if (userR.isSuccess() && userR.getData() != null) {
			User user = userR.getData();
			user.setPhone(dto.getPhone());
			user.setRoleId(dto.getRoleIds());
			user.setPostId(dto.getPostIds());
			user.setName(dto.getName());
			user.setDeptId(String.valueOf(dto.getDeptId()));
			R<Boolean> booleanR = userClient.updateUser(user);
			flag = booleanR.isSuccess();
		}
		return flag;
	}
}
